#include <unknwn.h>
#include <stdio.h>

#include "jtvrem.h"
#include "jtvremsk.h"


long (* INIT_IO)(void);
void (* FREE_IO)(void);
long (* SETGPDATABITS)(long FromBit,long ToBit,long Value,long offset);
long (* I2CISINITOK)(void);
long (* I2CINITSWMODE)(long freq);
long (* I2CSWSTART)(void);
long (* I2CSWSTOP)(void);
long (* I2CSWREAD)(BYTE *value);
long (* I2CSWWRITE)(BYTE value);
long (* I2CSWSENDACK)(void);
long (* I2CSWSENDNACK)(void);


KeyDef keys[]=
{

        { 0x1c, "Key_Power", "Power",},  
        { 0x15, "Key_Source", "Source", }, 
        
        { 0x12, "Key_PcVid", "Key_FullScreen", },

        { 0x11, "Key_Still", "Key_Capture", },
        { 0x0f, "Key_Window", "Key_Window", },
        { 0x13, "Key_AirCable", "Key_AirCableTV", },
        { 0x10, "Key_Mute", "Mute", },

        { 0x01, "Key_1", "1", },
        { 0x02, "Key_2", "2", },
        { 0x03, "Key_3", "3", },
        { 0x1A, "Key_VolumeUp", "VolumeUp", },

        { 0x04, "Key_4", "4", },
        { 0x05, "Key_5", "5", },
        { 0x06, "Key_6", "6", },
        { 0x1e, "Key_VolumeDown", "VolumeDown", },

        { 0x07, "Key_7", "7", },
        { 0x08, "Key_8", "8", },
        { 0x09, "Key_9", "9", },
        { 0x1B, "Key_ChannelUp", "ChannelUp", },

        { 0x0a, "Key_Loop", "Recall", },
        { 0x00, "Key_0", "0", },
        { 0x17, "Key_Enter", "Enter", },
        { 0x1f, "Key_ChannelDown", "ChannelDown", },

        { 0x0d, "Key_Play", "Play", },
        { 0x0e, "Key_Stop", "Stop", },
        { 0x1d, "Key_Left", "Fast Backwards", },
        { 0x19, "Key_Right", "Fast Forwards", },

        { 0x16, "Key_ADD", "Add", },
        { 0x14, "Key_Func", "Func", },
        { 0x18, "Key_PrevLinear", "-", },
        { 0x0c, "Key_NextLinear", "+", },

};

typedef UINT (CALLBACK* LPFNDLLFUNC1)(DWORD,UINT);


DWORD dwParam1;
UINT  uParam2, uReturnVal;
INT first_delay=300;	// default first delay for a key
INT repeat_delay=100;	// default repeat delay for a key


void log(const char* str, ...)
{
  va_list arglist;

  FILE* l=fopen("JTVRemote.log","a+t");
  if (l==NULL) return;
  va_start( arglist, str );
  vfprintf(l, str, arglist );
  va_end( arglist );
  fclose(l);

}

class JTVRemote : public CRemoteDriver
{

public:

        JTVRemote(KeyDef *k, int count) : CRemoteDriver(k, count)
		{
			log("******************************************************\n");
			log("*   Initializing Tekram M205pro remote module.       *\n");
            log("*(c)2001 Dandruff, <t_gl@pisem.net>.                 *\n");
            log("*(c)2001 - 2002 MRV, <MTV_MVV@intbel.ru>(WDM version)*\n");
			log("******************************************************\n");
		};


        void PollingThread()
        {
         first_delay=GetPrivateProfileInt("JTVRemote","KeyFirstDelay",first_delay,".\\jtv.ini");
         repeat_delay=GetPrivateProfileInt("JTVRemote","KeyRepeatDelay",repeat_delay,".\\jtv.ini");
		 log("KeyFirstDelay=%d, KeyRepeatDelay=%d\n",first_delay,repeat_delay);
  
		 HANDLE drvhandle;
 

         BYTE cod,last_code=0xFF,cod2;
		 
		  
		 drvhandle = LoadLibrary("IOCtrl.dll");
   
		if( (int) drvhandle < 32 ) MessageBox(NULL,"Can't load IOCtrl.dll","Error dll",0);

   *((FARPROC *)&INIT_IO)=GetProcAddress(drvhandle,"INIT_IO");
   
   *((FARPROC *)&FREE_IO)=GetProcAddress(drvhandle,"FREE_IO");
   
   *((FARPROC *)&I2CISINITOK)=GetProcAddress(drvhandle,"I2CISINITOK");
   
   *((FARPROC *)&SETGPDATABITS)=GetProcAddress(drvhandle,"SETGPDATABITS");
  
   *((FARPROC *)&I2CINITSWMODE)=GetProcAddress(drvhandle,"I2CINITSWMODE");
   
   *((FARPROC *)&I2CSWSTART)=GetProcAddress(drvhandle,"I2CSWSTART");
   
   *((FARPROC *)&I2CSWSTOP)=GetProcAddress(drvhandle,"I2CSWSTOP");
   
   *((FARPROC *)&I2CSWREAD)=GetProcAddress(drvhandle,"I2CSWREAD");
   
   *((FARPROC *)&I2CSWWRITE)=GetProcAddress(drvhandle,"I2CSWWRITE");
   
   *((FARPROC *)&I2CSWSENDACK)=GetProcAddress(drvhandle,"I2CSWSENDACK");
   
   *((FARPROC *)&I2CSWSENDNACK)=GetProcAddress(drvhandle,"I2CSWSENDNACK");
   
 
if (SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_HIGHEST)!=0) log("Set High priority for current thread\n");

		//Set volume in tekram
   		   log("Set volume Tekram in jtv.ini ->[JTVRemote]->TekVolume 0-15,16-not use\n");
		   int TekVolume=16;
           TekVolume=GetPrivateProfileInt("JTVRemote","TekVolume",TekVolume,".\\jtv.ini");

		   
				   CoInitialize(NULL);
		 
		   INIT_IO();	
		  
			log("IOCtrl.dll initialized ...\n");	 

				 
				 if (TekVolume<16)
		   {
    		 log("Tekram volume is %d\n",TekVolume);
		     TekVolume=15-TekVolume;
		     int VAud=(1<<((TekVolume>>2)&0x03))+(0x80<<(TekVolume&0x3))+0x6000;
  

			 for (int i=0;i!=0x12;i++)
			     {
			     SETGPDATABITS(1,1,(VAud>>i)&1,0);
			     SETGPDATABITS(0,0,1,0);
			     SETGPDATABITS(0,0,0,0);
			     }
			   SETGPDATABITS(1,1,0,0);
			   SETGPDATABITS(2,2,1,0);
			   SETGPDATABITS(2,2,0,0);
		   log("Sound Volume Initialized ...\n");
			}

// initializing Remote

			 I2CISINITOK();
	         
			 I2CINITSWMODE(10000);       //default 200kGz but work in 10-300 
			 
                    while (WaitForSingleObject(hBreakEvent, 0) != WAIT_OBJECT_0)
                    {
					  	 I2CSWSTART()     ;
					  	 I2CSWWRITE(0xAA) ;
					  	 I2CSWWRITE(0x1)  ;
					  	 I2CSWSTART()     ;
					  	 I2CSWWRITE(0xAB) ;
					  	 I2CSWREAD(&cod)  ;
					  	 I2CSWSENDACK()   ;
					  	 I2CSWREAD(&cod2) ;
					  	 I2CSWSENDNACK()  ;
					  	 I2CSWSTOP();
					  	 if	(cod==0x86)
                         {			// any key is pressed
							 if (last_code == cod2)
                            {		// auto repeat for any pressed key
		                       AddStroke(last_code);
							   Sleep(repeat_delay);
                            } 
                            else
                            {		// first run for any pressed key 
                               last_code = cod2;
							   AddStroke(last_code);
		                       Sleep(first_delay);
                            }
                         }
                         else  // no one key is pressed
						 {	 
                            last_code = 0xFF;
                            Sleep(repeat_delay);
                         }
                    }

                log("TekM205pW2k: Break event received. Exiting!\n");
                

                FREE_IO();  
				
				CoUninitialize();

				
				FreeLibrary(drvhandle);
                };
        
};

extern "C"
{
        __declspec(dllexport) IJTVRemoteControl *__stdcall GetInterfacePtr()
        {
                return new JTVRemote(keys, sizeof(keys) / sizeof(keys[0]));
        };
};

